| Assembly Source File
| Created 27/11/2003; 22:21:56

/*.global COMPILE_FOR_TI89
COMPILE_FOR_TI89:*/

.ifdef COMPILE_FOR_TI89
.xdef _ti89
.else
.xdef _ti92plus
.xdef _v200
.endif

| Constants for TI89
.ifdef COMPILE_FOR_TI89
.equ SHIFT_KEY,5
.equ HAND_KEY,7
.equ LEFT_KEY,1
.equ UP_KEY,0
.equ RIGHT_KEY,3
.equ DOWN_KEY,2
.equ ESC_ROW,64
.equ ESC_KEY,0
.equ SCREEN_WIDTH,160
.equ SCREEN_HEIGHT,100
| Constants for TI92+/V200
.else
.equ SHIFT_KEY,2
.equ HAND_KEY,3
.equ LEFT_KEY,4
.equ UP_KEY,5
.equ RIGHT_KEY,6
.equ DOWN_KEY,7
.equ ESC_ROW,256
.equ ESC_KEY,6
.equ SCREEN_WIDTH,240
.equ SCREEN_HEIGHT,128
.endif
| Constants for all calc models
.equ LCD_SIZE,3840
.equ LCD_MEM,0x4C00
.equ AMS_jump_table,0xC8
.equ memcpy,0x26A
.equ FontSetSys,0x18F
.equ DrawChar,0x1A4
.equ DrawString,0x1A9
.equ ST_helpMsg,0xE6

.global main

main:
	movem.l %d3-%d7/%a2-%a5,-(%a7)
	| Save interrupts
	move.l 0x64.w,-(%a7)
	move.l 0x68.w,-(%a7)
	lea dummy_int(%pc),%a0
	move.l %a0,(0x40064)
	move.l %a0,(0x40068)
	| Allocates the tile array on the stack
	link %a6,#-((30*16+4)+LCD_SIZE) | (4 bytes for cursor position saving and 3840 for screen saving)
	movea.l %a7,%a5 | a5 will be a pointer to the tile aray
	movea.l AMS_jump_table,%a4
	| Save the screen
	pea LCD_SIZE
	pea LCD_MEM
	pea 30*16+4(%a5)
	movea.l 4*memcpy(%a4),%a3
	jsr (%a3)
	lea 12(%a7),%a7
	moveq #0,%d0
	move.b (0x600017),%d0
	move.l %d0,__randseed
__game_init:
	.ifdef COMPILE_FOR_TI89
	jbsr clear_screen
	.endif
	| Clear tile array
	moveq #29,%d0
	movea.l %a5,%a0
	move.l #0x80808080,%d1
	move.l %d1,%d2
	move.l %d2,%d3
	move.l %d3,%d4
__tile_array_clear_loop:
	| Set 16 bytes per loop
	movem.l %d1-%d4,(%a0)
	adda.w #16,%a0
	dbf %d0,__tile_array_clear_loop
	| Place bombs on the map
	.ifdef COMPILE_FOR_TI89
	moveq #31,%d4 | Place 32 bombs
	.else
	moveq #63,%d4 | Place 64 bombs
	.endif
__place_bombs_loop:
	jbsr rand
	lsr.w #7,%d0
	lsr.w #4,%d0
	move.w %d0,%d3
	.ifdef COMPILE_FOR_TI89
	cmpi.w #12,%d3
	jbge __place_bombs_loop
	.endif
	jbsr rand
	.ifdef COMPILE_FOR_TI89
	lsr.w #7,%d0
	mulu.w #20,%d0
	lsr.w #4,%d0
	lsr.w #4,%d0
	.else
	lsr.w #7,%d0
	lsr.w #3,%d0
	cmpi.w #30,%d0
	jbge __place_bombs_loop
	.endif
	move.w %d3,%d1
	jbsr get_cell_addr
	btst.b #5,%d0
	jbne __place_bombs_loop
	jbsr place_bomb
	dbf %d4,__place_bombs_loop
	| Set font
	movea.l 4*FontSetSys(%a4),%a3
	move.w #0,-(%a7)
	jsr (%a3)
	lea 2(%a7),%a7
	| Initialise global variables
	moveq #0,%d5 | d5 will contain status information
	moveq #0,%d6 | d6 will store the cursor's x position
	moveq #0,%d7 | d7 will store the cursor's y position
	| Save cursor pos
	move.w %d6,30*16(%a5)
	move.w %d7,30*16+2(%a5)
__draw_screen:
	| Draw the map
	moveq #0,%d3 | map y
	movea.l %a5,%a2 | cell pointer 
	movea.l 4*DrawChar(%a4),%a3 | Load DrawChar address
__y_iter:
	moveq #0,%d4 | map x
__x_iter:
	| Draw cell
	move.w %d4,%d0
	move.w %d3,%d1
	move.b (%a2),%d2
	btst.b #7,%d2
	jbne __unrevealed_cell
	btst.b #5,%d2
	jbne __bombed_cell
	lea empty_cell(%pc),%a0
	andi.b #15,%d2
	jbeq __no_number_to_draw
	| If we're here, we have a number to draw
	addi.b #0x30,%d2
	move.w #1,-(%a7) | A_NORMAL
	move.w %d2,-(%a7) | character to draw
	| Process char's y
	move.w %d1,%d2 | Load cell y in d2
	lsl.w #3,%d2
	addq.w #2,%d2
	move.w %d2,-(%a7)
	| Process char's x
	move.w %d0,%d2 | Load cell x in d2
	lsl.w #3,%d2
	addq.w #2,%d2
	move.w %d2,-(%a7)
	bset.b #2,%d5 | Draw number flag =)
__no_number_to_draw:
	jbra __iter_end
__bombed_cell:
	lea bombed_cell(%pc),%a0
	jbra __iter_end
__unrevealed_cell:
	btst.b #6,%d2
	jbne __flagged_cell
	lea unrevealed_cell(%pc),%a0
	jbra __iter_end
__flagged_cell:
	lea flagged_cell(%pc),%a0
	jbra __iter_end
__iter_end:
	jbsr draw_tile
	btst.b #2,%d5
	beq __cell_drawn
	bclr.b #2,%d5
	jsr (%a3)
	addq.w #8,%a7
__cell_drawn:
	addq.w #1,%a2
	addq.b #1,%d4
	.ifdef COMPILE_FOR_TI89
	cmpi.b #20,%d4
	.else
	cmpi.b #30,%d4
	.endif
	jbne __x_iter
	addq.b #1,%d3
	.ifdef COMPILE_FOR_TI89
	cmpi.b #12,%d3
	adda.w #10,%a2
	.else
	cmpi.b #16,%d3
	.endif
	jbne __y_iter
	| Draw the cursor
	move.w %d6,%d0
	move.w %d7,%d1
	jbsr draw_cursor
	| Reset flags
	bclr.b #1,%d5
	bclr.b #0,%d5
	| Draw text if needed
	btst.b #3,%d5 | Check if the game is finished
	jbeq __draw_end | Jump if not
	.ifdef COMPILE_FOR_TI89
	move.w #0,-(%a7)
	.else
	move.w #1,-(%a7)
	.endif
	move.l 4*FontSetSys(%a4),%a3
	jsr (%a3)
	move.w #4,-(%a7)
	btst.b #4,%d5
	jbne __win_text
	pea lose_string(%pc)
	jbra __draw_text
__win_text:
	pea win_string(%pc)
__draw_text:
	.ifdef COMPILE_FOR_TI89
	pea 0x000D002F
	.else
	pea 0x0003003C
	.endif
	move.l 4*DrawString(%a4),%a2
	jsr (%a2)
	move.w #0,-(%a7)
	jsr (%a3)
	lea 14(%a7),%a7
__draw_end:
	| Waits until all the keys have been released :)
	jbsr wait_nokey
	| Save cursor pos (not doing it could cause little bugs :p)
	move.w %d6,30*16(%a5)
	move.w %d7,30*16+2(%a5)
__game_loop:
	| Reads keyboard
	move.w #1,%d0
	jbsr rowread
	move %d0,%d3
	| LEFT Key
__left_test:
	btst.b #LEFT_KEY,%d3
	jbeq __up_test
__left_key:
	move.w #-1,%d0
	move.w #0,%d1
	jbsr move_cursor
	| UP Key
__up_test:
	btst.b #UP_KEY,%d3
	jbeq __right_test
__up_key:
	move.w #0,%d0
	move.w #-1,%d1
	jbsr move_cursor
	| RIGHT Key
__right_test:
	btst.b #RIGHT_KEY,%d3
	jbeq __down_test
__right_key:
	move.w #1,%d0
	move.w #0,%d1
	jbsr move_cursor
	| DOWN Key
__down_test:
	btst.b #DOWN_KEY,%d3
	jbeq __hand_test
__down_key:
	move.w #0,%d0
	move.w #1,%d1
	jbsr move_cursor
	| HAND Key
__hand_test:
	btst.b #HAND_KEY,%d3
	jbeq __shift_test
__hand_key:
	btst.b #3,%d5 | Test if the game is finished
	jbne __game_init | And if finished, begin a new game :)
	move.w %d6,%d0
	lsr.w #3,%d0
	move.w %d7,%d1
	lsr.w #3,%d1
	jbsr reveal_cell
	jbsr check_victory
	bset.b #1,%d5
	| SHIFT Key
__shift_test:
	btst.b #3,%d5 | Test if the player can still play
	jbne __esc_test | And if not, he can only quit
	btst.b #SHIFT_KEY,%d3
	jbeq __esc_test
__shift_key:
	move.w %d6,%d0
	lsr.w #3,%d0
	move.w %d7,%d1
	lsr.w #3,%d1
	jbsr flag_cell
	bset #1,%d5
	| ESC Key
__esc_test:
	move.w #ESC_ROW,%d0
	jbsr rowread
	btst.b #ESC_KEY,%d0
	jbne __game_uninit
	| Test status flags
	btst.b #1,%d5
	bne __draw_screen
	btst.b #0,%d5
	beq __game_loop
__redraw_cursor:
	| Redraw the cursor
	move.w 30*16(%a5),%d0
	move.w 30*16+2(%a5),%d1
	jbsr draw_cursor
	move.w %d6,%d0
	move.w %d7,%d1
	jbsr draw_cursor
	move.w %d6,30*16(%a5)
	move.w %d7,30*16+2(%a5)
	bclr.b #0,%d5
	jbsr wait
	bra __game_loop
__game_uninit:
	| Restore the screen
	pea LCD_SIZE
	pea 30*16+4(%a5)
	pea LCD_MEM
	movea.l 4*memcpy(%a4),%a3
	jsr (%a3)
	| Free the dynamically allocated array
	unlk %a6
	| Restore interrupts
	move.l (%a7)+,(0x40068)
	move.l (%a7)+,(0x40064)
	pea about_string(%pc)
	movea.l 4*ST_helpMsg(%a4),%a3
	jsr (%a3)
	addq.w #4,%a7
	movem.l (%a7)+,%d3-%d7/%a2-%a5
	rts

| d0.w: cell x on map
| d1.w: cell y on map
| Returns cell address in a0
get_cell_addr:
	movem.l %d0-%d1,-(%a7)
	lsl.w #1,%d1
	add.w %d1,%d0
	lsl.w #1,%d1
	add.w %d1,%d0
	lsl.w #1,%d1
	add.w %d1,%d0
	lsl.w #1,%d1
	add.w %d1,%d0
	lea (%d0.w,%a5),%a0
	movem.l (%a7)+,%d0-%d1
	rts

| d0.w: cell x on map
| d1.w: cell y on map
increment_counter:
	movem.l %d0-%d1/%a0,-(%a7)
	tst.w %d0
	jblt __ic_end
	tst.w %d1
	jblt __ic_end
	cmpi.w #30,%d0
	jbge __ic_end
	cmpi.w #16,%d1
	jbge __ic_end
	jbsr get_cell_addr
	btst.b #5,(%a0)
	jbne __ic_end
	addq.b #1,(%a0)
__ic_end:
	movem.l (%a7)+,%d0-%d1/%a0
	rts

| d0.w: cell x on map
| d1.w: cell y on map
flag_cell:
	movem.l %d0-%d1/%a0,-(%a7)
	tst.w %d0
	jblt __fc_end
	tst.w %d1
	jblt __fc_end
	cmpi.w #30,%d0
	jbge __fc_end
	cmpi.w #16,%d1
	jbge __fc_end
	jbsr get_cell_addr
	btst.b #7,(%a0)
	jbeq __fc_end
	bchg.b #6,(%a0)
__fc_end:
	movem.l (%a7)+,%d0-%d1/%a0
	rts

| d0.w: cell x on map
| d1.w: cell y on map
place_bomb:
	movem.l %d0-%d1/%a0,-(%a7)
	jbsr get_cell_addr
	btst.b #5,(%a0)
	jbne __pb_end
	bset.b #5,(%a0)
	andi.b #0xF0,(%a0)
	subq.w #1,%d0
	subq.w #1,%d1
	jbsr increment_counter
	addq.w #1,%d0
	jbsr increment_counter
	addq.w #1,%d0
	jbsr increment_counter
	addq.w #1,%d1
	jbsr increment_counter
	subq.w #2,%d0
	jbsr increment_counter
	addq.w #1,%d1
	jbsr increment_counter
	addq.w #1,%d0
	jbsr increment_counter
	addq.w #1,%d0
	jbsr increment_counter
__pb_end:
	movem.l (%a7)+,%d0-%d1/%a0
	rts

| d0.w: cell x on map
| d1.w: cell y on map
reveal_cell:
	movem.l %d0-%d2/%a0,-(%a7)
	tst.w %d0
	jblt __rc_end
	tst.w %d1
	jblt __rc_end
	cmpi.w #30,%d0
	jbge __rc_end
	cmpi.w #16,%d1
	jbge __rc_end
	jbsr get_cell_addr
	move.b (%a0),%d2
	btst.b #6,%d2
	jbne __rc_end
	btst.b #7,%d2
	jbeq __rc_end
	bclr.b #7,(%a0) | Discover the cell
	btst.b #5,%d2 | Tests if the discovered cell is a bomb
	jbeq __rc_continue | If not, jump
	bset.b #3,%d5 | Set the "game finished" flag
	jbra __rc_end
__rc_continue:
	andi.w #15,%d2
	jbne __rc_end
	subq.w #1,%d0
	subq.w #1,%d1
	jbsr reveal_cell
	addq.w #1,%d0
	jbsr reveal_cell
	addq.w #1,%d0
	jbsr reveal_cell
	addq.w #1,%d1
	jbsr reveal_cell
	subq.w #2,%d0
	jbsr reveal_cell
	addq.w #1,%d1
	jbsr reveal_cell
	addq.w #1,%d0
	jbsr reveal_cell
	addq.w #1,%d0
	jbsr reveal_cell
__rc_end:
	movem.l (%a7)+,%d0-%d2/%a0
	rts

check_victory:
	movea.l %a5,%a0
	move.w #30*16-1,%d0
	bclr.b #4,%d5 | Unset the victory flag
__cv_loop:
	move.b (%a0)+,%d1
	btst.b #7,%d1
	jbeq __cv_revealed_test
	btst.b #5,%d1 | Test if the unrevealed cell is a bomb
	jbeq __cv_end | If not, then the game isn't finished
	jbra __cv_loop_end
__cv_revealed_test:
	btst.b #5,%d1 | Test if it is a bomb
	jbne __cv_end | If yes, then it's a defeat
__cv_loop_end:
	dbf %d0,__cv_loop
	| If all the tests were successful, then it is a victory
	bset.b #3,%d5 | Set the "game finished" flag
	bset.b #4,%d5 | Set the victory flag
__cv_end:
	rts

| d0.w: x increment
| d1.w: y increment
move_cursor:
	add.w %d0,%d6
	tst.w %d6
	jblt __mc_x_toolow
	cmpi.w #SCREEN_WIDTH - 8,%d6
	jbhi __mc_x_toohigh
	jbra __mc_y_increment
__mc_x_toolow:
	moveq #0,%d6
	jbra __mc_y_increment
__mc_x_toohigh:
	move.w #SCREEN_WIDTH - 8,%d6
__mc_y_increment:
	add.w %d1,%d7
	tst.w %d7
	jblt __mc_y_toolow
	cmpi.w #SCREEN_HEIGHT - 8,%d7
	jbhi __mc_y_toohigh
	jbra __mc_end
__mc_y_toolow:
	moveq #0,%d7
	jbra __mc_end
__mc_y_toohigh:
	move.b #SCREEN_HEIGHT - 8,%d7
__mc_end:
	bset.b #0,%d5
	rts

| d0.w: keyboard row mask
| Outputs column mask in d0.b
rowread:
	not.w %d0
	andi.w #0x3FF,%d0
	move.w %d0,(0x600018)
	move.w #23,%d0
__rr_loop:
	dbf %d0,__rr_loop
	| Read value and store it in d0
	move.b (0x60001B),%d0
	not.b %d0
	rts

| destroy d0
wait_nokey:
	move.w #0x3FF,%d0
	jbsr rowread
	andi.b #0xFF,%d0
	jbne wait_nokey
	rts

/*clear_screen:
	| Save every register (except a7 ;)
	movem.l %d0-%d7/%a0-%a6,-(%a7)
	| Clear all registers
	moveq #0,%d1
	move.l %d1,%d2
	move.l %d2,%d3
	move.l %d3,%d4
	move.l %d4,%d5
	move.l %d5,%d6
	move.l %d6,%d7
	movea.l %d7,%a0
	movea.l %a0,%a1
	movea.l %a1,%a2
	movea.l %a2,%a3
	movea.l %a3,%a4
	movea.l %a4,%a5
	| Initialise loop
	moveq #5,%d0 | we must loop 7 times
	lea 0x4C00.w,%a6
__cs_loop:
	movem.l %d1-%d7/%a0-%a5,(%a6) | 52 bytes
	movem.l %d1-%d7/%a0-%a5,52(%a6) | ...
	movem.l %d1-%d7/%a0-%a5,104(%a6)
	movem.l %d1-%d7/%a0-%a5,156(%a6)
	movem.l %d1-%d7/%a0-%a5,208(%a6)
	movem.l %d1-%d7/%a0-%a5,260(%a6)
	movem.l %d1-%d7/%a0-%a5,312(%a6)
	movem.l %d1-%d7/%a0-%a5,364(%a6)
	movem.l %d1-%d7/%a0-%a5,416(%a6)
	movem.l %d1-%d7/%a0-%a5,468(%a6)
	movem.l %d1-%d7/%a0-%a5,520(%a6)
	movem.l %d1-%d7/%a0-%a5,572(%a6)
	movem.l %d1-%d4,624(%a6) | 16 bytes
	adda.w #640,%a6
	dbf %d0,__cs_loop
	| Restore other registers
	movem.l (%a7)+,%d0-%d7/%a0-%a6
	rts*/

.ifdef COMPILE_FOR_TI89
clear_screen: | Optimized for size
	move.w #749,%d0
	lea LCD_MEM,%a0
__cs_loop:
	clr.l (%a0)+
	dbf %d0,__cs_loop
	rts
.endif

| d0.w: column (0 - 29)
| d1.w: line (0 - 16)
| a0.l: tile
| refisters d0,d1,a0,a1 are modified
draw_tile:
	lsl.w #4,%d1
	add.w %d1,%d0
	lsl.w #1,%d1
	add.w %d1,%d0
	lsl.w #1,%d1
	add.w %d1,%d0
	lsl.w #1,%d1
	add.w %d1,%d0
	lea 0x4C00.w,%a1
	lea (%d0.w,%a1),%a1
	moveq #7,%d1
__dt_loop:
	move.b (%a0)+,(%a1)
	adda.w #30,%a1
	dbf %d1,__dt_loop
	rts

| d0.w: x
| d1.w: y
| registers d0,d1,d2,a0,a1 are modified
draw_cursor:
	move.w %d0,%d2 | copy d0 in d2
	not.b %d2 | invert d2
	andi.w #15,%d2 | masks out the bits not needed and we have the sifting
	addq.w #8,%d2
	lsr.w #3,%d0
	bclr.b #0,%d0 | always clear this bit to have a correct address
	lsl.w #1,%d1
	add.w %d1,%d0
	lsl.w #1,%d1
	add.w %d1,%d0
	lsl.w #1,%d1
	add.w %d1,%d0
	lsl.w #1,%d1
	add.w %d1,%d0
	lea 0x4C00.w,%a0
	lea (%d0.w,%a0),%a0
	lea cursor(%pc),%a1
	moveq #7,%d1
__dc_loop:
	moveq #0,%d0
	move.b (%a1)+,%d0
	lsl.l %d2,%d0
	eor.l %d0,(%a0)
	adda.w #30,%a0
	dbf %d1,__dc_loop
	rts

wait:
	move.w #32000,%d0
__wait_loop:
	dbf %d0,__wait_loop
	rts

dummy_int:
	rte

.data

about_string:
	.string "TinyMine v1.02 by GoldenCrystal"
lose_string:
	.string "You lose. Press [@] to start a new game"
win_string:
	.string "You win.  Press [@] to start a new game"
cursor:
	.byte 0x80, 0xC0, 0xE0, 0xF0, 0xE0, 0xB0, 0x10, 0x18
unrevealed_cell:
	.byte 0x01, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0xFF
flagged_cell:
	.byte 0x01, 0x7F, 0x47, 0x47, 0x77, 0x77, 0x63, 0xFF
bombed_cell:
	.byte 0xFF, 0x80, 0x92, 0xAD, 0x9E, 0x9E, 0xAD, 0x92
empty_cell:
	.byte 0xFF, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80

.comm _nostub,2
